﻿using System;
using OpenTK;
using OpenTK.Graphics;
using OpenTK.Graphics.OpenGL;

public class FontRenderer
{
    private Fonter fonter = new Fonter();
    private int fontTextureId;
    private int fontVboId;


    public FontRenderer()
    {
    }


    public void Init( string workingDirectory )
    {
        fonter.LoadBMFontMetaText( workingDirectory + "/Resources/font.fnt" );
        fontTextureId = MatchFree.Utils.LoadTexture( workingDirectory + "/Resources/font.png" );
        GL.GenBuffers( 1, out fontVboId );
    }


    public void DrawText( string text, float x, float y, float scale )
    {
        Vector4[] fontGeom = fonter.CreateGeometry( text, x, y, scale );

        GL.BindBuffer( BufferTarget.ArrayBuffer, fontVboId );
        GL.BufferData< Vector4 >( BufferTarget.ArrayBuffer, new IntPtr( fontGeom.Length * Vector4.SizeInBytes ), fontGeom, BufferUsageHint.StaticDraw );

        GL.EnableVertexAttribArray( 0 );
        GL.VertexAttribPointer( 0, 4, VertexAttribPointerType.Float, false, Vector4.SizeInBytes, 0 );
        GL.BindBuffer( BufferTarget.ArrayBuffer, 0 );

        GL.BindTexture( TextureTarget.Texture2D, fontTextureId );
        GL.BindBuffer( BufferTarget.ArrayBuffer, fontVboId );
        GL.DrawArrays( PrimitiveType.Triangles, 0, fontGeom.Length );
        GL.BindBuffer( BufferTarget.ArrayBuffer, 0 );
    }
}

